
_Terminate:

;ExtRes_to_AT45DB.c,102 :: 		void Terminate() {
;ExtRes_to_AT45DB.c,103 :: 		Mmc_Fat_Close();  // Close currently opened file
	CALL        _Mmc_Fat_Close+0, 0
;ExtRes_to_AT45DB.c,104 :: 		while (1) {
L_Terminate0:
;ExtRes_to_AT45DB.c,105 :: 		Delay_ms(1000);
	MOVLW       41
	MOVWF       R11, 0
	MOVLW       150
	MOVWF       R12, 0
	MOVLW       127
	MOVWF       R13, 0
L_Terminate2:
	DECFSZ      R13, 1, 1
	BRA         L_Terminate2
	DECFSZ      R12, 1, 1
	BRA         L_Terminate2
	DECFSZ      R11, 1, 1
	BRA         L_Terminate2
;ExtRes_to_AT45DB.c,106 :: 		}
	GOTO        L_Terminate0
;ExtRes_to_AT45DB.c,107 :: 		}
L_end_Terminate:
	RETURN      0
; end of _Terminate

_CodeTxtToRamTxt:

;ExtRes_to_AT45DB.c,110 :: 		char* CodeTxtToRamTxt(const char* ctxt) {
;ExtRes_to_AT45DB.c,113 :: 		for (i = 0; ramTxt[i] = ctxt[i]; i++);
	CLRF        R3 
L_CodeTxtToRamTxt3:
	MOVLW       CodeTxtToRamTxt_ramTxt_L0+0
	MOVWF       R1 
	MOVLW       hi_addr(CodeTxtToRamTxt_ramTxt_L0+0)
	MOVWF       R2 
	MOVF        R3, 0 
	ADDWF       R1, 1 
	BTFSC       STATUS+0, 0 
	INCF        R2, 1 
	MOVF        R3, 0 
	ADDWF       FARG_CodeTxtToRamTxt_ctxt+0, 0 
	MOVWF       TBLPTRL 
	MOVLW       0
	ADDWFC      FARG_CodeTxtToRamTxt_ctxt+1, 0 
	MOVWF       TBLPTRH 
	MOVLW       0
	ADDWFC      FARG_CodeTxtToRamTxt_ctxt+2, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R0
	MOVFF       R1, FSR1
	MOVFF       R2, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVFF       R1, FSR0
	MOVFF       R2, FSR0H
	MOVF        POSTINC0+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_CodeTxtToRamTxt4
	INCF        R3, 1 
	GOTO        L_CodeTxtToRamTxt3
L_CodeTxtToRamTxt4:
;ExtRes_to_AT45DB.c,114 :: 		return ramTxt;
	MOVLW       CodeTxtToRamTxt_ramTxt_L0+0
	MOVWF       R0 
	MOVLW       hi_addr(CodeTxtToRamTxt_ramTxt_L0+0)
	MOVWF       R1 
;ExtRes_to_AT45DB.c,115 :: 		}
L_end_CodeTxtToRamTxt:
	RETURN      0
; end of _CodeTxtToRamTxt

_Wait_for_Card:

;ExtRes_to_AT45DB.c,118 :: 		void Wait_for_Card() {
;ExtRes_to_AT45DB.c,119 :: 		Mmc_Card_Detect_Direction = 1;  // Set microSD card detection pin to be input
	BSF         TRISC1_bit+0, 1 
;ExtRes_to_AT45DB.c,121 :: 		if (Mmc_Card_Detect) {
	BTFSS       RC1_bit+0, 1 
	GOTO        L_Wait_for_Card6
;ExtRes_to_AT45DB.c,122 :: 		Lcd_Cmd(_LCD_CLEAR);                   // Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;ExtRes_to_AT45DB.c,123 :: 		Lcd_Out(1,1,CodeTxtToRamTxt(txt_01));  // Write text in first row ("Insert microSD  ")
	MOVLW       _txt_01+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_01+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_01+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,124 :: 		while (Mmc_Card_Detect) {              // Loop until card is detected
L_Wait_for_Card7:
	BTFSS       RC1_bit+0, 1 
	GOTO        L_Wait_for_Card8
;ExtRes_to_AT45DB.c,125 :: 		Delay_ms(500);
	MOVLW       21
	MOVWF       R11, 0
	MOVLW       75
	MOVWF       R12, 0
	MOVLW       190
	MOVWF       R13, 0
L_Wait_for_Card9:
	DECFSZ      R13, 1, 1
	BRA         L_Wait_for_Card9
	DECFSZ      R12, 1, 1
	BRA         L_Wait_for_Card9
	DECFSZ      R11, 1, 1
	BRA         L_Wait_for_Card9
	NOP
;ExtRes_to_AT45DB.c,126 :: 		}
	GOTO        L_Wait_for_Card7
L_Wait_for_Card8:
;ExtRes_to_AT45DB.c,127 :: 		Lcd_Out(1,1,CodeTxtToRamTxt(txt_02));  // Write text in first row ("MicroSD inserted")
	MOVLW       _txt_02+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_02+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_02+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,128 :: 		Delay_ms(2000);
	MOVLW       82
	MOVWF       R11, 0
	MOVLW       43
	MOVWF       R12, 0
	MOVLW       0
	MOVWF       R13, 0
L_Wait_for_Card10:
	DECFSZ      R13, 1, 1
	BRA         L_Wait_for_Card10
	DECFSZ      R12, 1, 1
	BRA         L_Wait_for_Card10
	DECFSZ      R11, 1, 1
	BRA         L_Wait_for_Card10
	NOP
;ExtRes_to_AT45DB.c,129 :: 		}
L_Wait_for_Card6:
;ExtRes_to_AT45DB.c,130 :: 		}
L_end_Wait_for_Card:
	RETURN      0
; end of _Wait_for_Card

_Card_Init:

;ExtRes_to_AT45DB.c,133 :: 		void Card_Init() {
;ExtRes_to_AT45DB.c,135 :: 		SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV64, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
	MOVLW       2
	MOVWF       FARG_SPI1_Init_Advanced_master+0 
	CLRF        FARG_SPI1_Init_Advanced_data_sample+0 
	CLRF        FARG_SPI1_Init_Advanced_clock_idle+0 
	MOVLW       1
	MOVWF       FARG_SPI1_Init_Advanced_transmit_edge+0 
	CALL        _SPI1_Init_Advanced+0, 0
;ExtRes_to_AT45DB.c,137 :: 		switch (Mmc_Fat_Init()) {  // Initialize microSD card
	CALL        _Mmc_Fat_Init+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__Card_Init+0 
	GOTO        L_Card_Init11
;ExtRes_to_AT45DB.c,138 :: 		case 1:    // FAT16 boot sector not found
L_Card_Init13:
;ExtRes_to_AT45DB.c,139 :: 		Lcd_Out(1,1,CodeTxtToRamTxt(txt_03));  // Write text in first row ("MicroSD error!  ")
	MOVLW       _txt_03+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_03+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_03+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,140 :: 		Lcd_Out(2,1,CodeTxtToRamTxt(txt_04));  // Write text in second row ("FAT16 not found ")
	MOVLW       _txt_04+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_04+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_04+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,141 :: 		Terminate();
	CALL        _Terminate+0, 0
;ExtRes_to_AT45DB.c,142 :: 		case 255:  // MicroSD card not detected
L_Card_Init14:
;ExtRes_to_AT45DB.c,143 :: 		Lcd_Out(1,1,CodeTxtToRamTxt(txt_03));  // Write text in first row ("MicroSD error!  ")
	MOVLW       _txt_03+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_03+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_03+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,144 :: 		Lcd_Out(2,1,CodeTxtToRamTxt(txt_05));  // Write text in second row ("Reinsert & reset")
	MOVLW       _txt_05+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_05+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_05+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,145 :: 		Terminate();
	CALL        _Terminate+0, 0
;ExtRes_to_AT45DB.c,146 :: 		}
	GOTO        L_Card_Init12
L_Card_Init11:
	MOVF        FLOC__Card_Init+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_Card_Init13
	MOVF        FLOC__Card_Init+0, 0 
	XORLW       255
	BTFSC       STATUS+0, 2 
	GOTO        L_Card_Init14
L_Card_Init12:
;ExtRes_to_AT45DB.c,149 :: 		SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV4, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
	CLRF        FARG_SPI1_Init_Advanced_master+0 
	CLRF        FARG_SPI1_Init_Advanced_data_sample+0 
	CLRF        FARG_SPI1_Init_Advanced_clock_idle+0 
	MOVLW       1
	MOVWF       FARG_SPI1_Init_Advanced_transmit_edge+0 
	CALL        _SPI1_Init_Advanced+0, 0
;ExtRes_to_AT45DB.c,151 :: 		Mmc_Fat_Assign("res_file.res", 0);
	MOVLW       ?lstr1_ExtRes_to_AT45DB+0
	MOVWF       FARG_Mmc_Fat_Assign_name+0 
	MOVLW       hi_addr(?lstr1_ExtRes_to_AT45DB+0)
	MOVWF       FARG_Mmc_Fat_Assign_name+1 
	CLRF        FARG_Mmc_Fat_Assign_attrib+0 
	CALL        _Mmc_Fat_Assign+0, 0
;ExtRes_to_AT45DB.c,152 :: 		Mmc_Fat_Reset(&resFileSize);  // To read file, procedure returns size of file
	MOVLW       _resFileSize+0
	MOVWF       FARG_Mmc_Fat_Reset_size+0 
	MOVLW       hi_addr(_resFileSize+0)
	MOVWF       FARG_Mmc_Fat_Reset_size+1 
	CALL        _Mmc_Fat_Reset+0, 0
;ExtRes_to_AT45DB.c,153 :: 		}
L_end_Card_Init:
	RETURN      0
; end of _Card_Init

_AT45DB_ReadStatusReg:

;ExtRes_to_AT45DB.c,155 :: 		void AT45DB_ReadStatusReg() {
;ExtRes_to_AT45DB.c,156 :: 		AT45DB_Chip_Select = 0;            // Select AT45DB memory chip
	BCF         LATC2_bit+0, 2 
;ExtRes_to_AT45DB.c,157 :: 		SPI1_Write(0xD7);                  // Request for Status Register bytes
	MOVLW       215
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,158 :: 		SPI_StatusReg1 = SPI1_Read(0xFF);  // Read byte 1 of Status Register
	MOVLW       255
	MOVWF       FARG_SPI1_Read_buffer+0 
	CALL        _SPI1_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _SPI_StatusReg1+0 
;ExtRes_to_AT45DB.c,159 :: 		SPI_StatusReg2 = SPI1_Read(0xFF);  // Read byte 2 of Status Register
	MOVLW       255
	MOVWF       FARG_SPI1_Read_buffer+0 
	CALL        _SPI1_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _SPI_StatusReg2+0 
;ExtRes_to_AT45DB.c,160 :: 		AT45DB_Chip_Select = 1;            // Deselect AT45DB memory chip
	BSF         LATC2_bit+0, 2 
;ExtRes_to_AT45DB.c,161 :: 		}
L_end_AT45DB_ReadStatusReg:
	RETURN      0
; end of _AT45DB_ReadStatusReg

_AT45DB_Check:

;ExtRes_to_AT45DB.c,163 :: 		void AT45DB_Check() {
;ExtRes_to_AT45DB.c,166 :: 		AT45DB_Chip_Select = 1;            // Deselect AT45DB memory chip
	BSF         LATC2_bit+0, 2 
;ExtRes_to_AT45DB.c,167 :: 		AT45DB_Chip_Select_Direction = 0;  // Set CS# pin as output
	BCF         TRISC2_bit+0, 2 
;ExtRes_to_AT45DB.c,169 :: 		AT45DB_ReadStatusReg();  // Read AT45DB Status Register
	CALL        _AT45DB_ReadStatusReg+0, 0
;ExtRes_to_AT45DB.c,170 :: 		if (SPI_StatusReg1 == 0x00 || SPI_StatusReg1 == 0xFF) {
	MOVF        _SPI_StatusReg1+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__AT45DB_Check61
	MOVF        _SPI_StatusReg1+0, 0 
	XORLW       255
	BTFSC       STATUS+0, 2 
	GOTO        L__AT45DB_Check61
	GOTO        L_AT45DB_Check17
L__AT45DB_Check61:
;ExtRes_to_AT45DB.c,171 :: 		Lcd_Out(1,1,CodeTxtToRamTxt(txt_06));  // Write text in first row ("Memory not found")
	MOVLW       _txt_06+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_06+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_06+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,172 :: 		Lcd_Out(2,1,CodeTxtToRamTxt(txt_07));  // Write text in second row ("Turn off & check")
	MOVLW       _txt_07+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_07+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_07+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,173 :: 		Terminate();
	CALL        _Terminate+0, 0
;ExtRes_to_AT45DB.c,174 :: 		}
L_AT45DB_Check17:
;ExtRes_to_AT45DB.c,175 :: 		if (SPI_StatusReg1 == SPI_StatusReg2) {
	MOVF        _SPI_StatusReg1+0, 0 
	XORWF       _SPI_StatusReg2+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_AT45DB_Check18
;ExtRes_to_AT45DB.c,176 :: 		memSeries = 'D';  // Atmel AT45DBxx1D detected
	MOVLW       68
	MOVWF       _memSeries+0 
;ExtRes_to_AT45DB.c,177 :: 		Lcd_Out(1,1,CodeTxtToRamTxt(txt_08));  // Write text in first row ("AT45DBxx1D found")
	MOVLW       _txt_08+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_08+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_08+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,178 :: 		} else {
	GOTO        L_AT45DB_Check19
L_AT45DB_Check18:
;ExtRes_to_AT45DB.c,179 :: 		memSeries = 'E';  // Atmel AT45DBxx1E detected
	MOVLW       69
	MOVWF       _memSeries+0 
;ExtRes_to_AT45DB.c,180 :: 		Lcd_Out(1,1,CodeTxtToRamTxt(txt_09));  // Write text in first row ("AT45DBxx1E found")
	MOVLW       _txt_09+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_09+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_09+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,181 :: 		}
L_AT45DB_Check19:
;ExtRes_to_AT45DB.c,182 :: 		Delay_ms(3000);
	MOVLW       122
	MOVWF       R11, 0
	MOVLW       193
	MOVWF       R12, 0
	MOVLW       129
	MOVWF       R13, 0
L_AT45DB_Check20:
	DECFSZ      R13, 1, 1
	BRA         L_AT45DB_Check20
	DECFSZ      R12, 1, 1
	BRA         L_AT45DB_Check20
	DECFSZ      R11, 1, 1
	BRA         L_AT45DB_Check20
	NOP
	NOP
;ExtRes_to_AT45DB.c,184 :: 		density = SPI_StatusReg1 & 0b00111100;
	MOVLW       60
	ANDWF       _SPI_StatusReg1+0, 0 
	MOVWF       AT45DB_Check_density_L0+0 
;ExtRes_to_AT45DB.c,185 :: 		switch (density) {
	GOTO        L_AT45DB_Check21
;ExtRes_to_AT45DB.c,186 :: 		case 0b00101100:    // Atmel AT45DB161x detected
L_AT45DB_Check23:
;ExtRes_to_AT45DB.c,187 :: 		memSize = 2097152;
	MOVLW       0
	MOVWF       _memSize+0 
	MOVLW       0
	MOVWF       _memSize+1 
	MOVLW       32
	MOVWF       _memSize+2 
	MOVLW       0
	MOVWF       _memSize+3 
;ExtRes_to_AT45DB.c,188 :: 		break;
	GOTO        L_AT45DB_Check22
;ExtRes_to_AT45DB.c,189 :: 		case 0b00110100:    // Atmel AT45DB321x detected
L_AT45DB_Check24:
;ExtRes_to_AT45DB.c,190 :: 		memSize = 4194304;
	MOVLW       0
	MOVWF       _memSize+0 
	MOVLW       0
	MOVWF       _memSize+1 
	MOVLW       64
	MOVWF       _memSize+2 
	MOVLW       0
	MOVWF       _memSize+3 
;ExtRes_to_AT45DB.c,191 :: 		break;
	GOTO        L_AT45DB_Check22
;ExtRes_to_AT45DB.c,192 :: 		default:
L_AT45DB_Check25:
;ExtRes_to_AT45DB.c,193 :: 		Lcd_Out(1,1,CodeTxtToRamTxt(txt_10));  // Write text in first row ("No supported mem")
	MOVLW       _txt_10+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_10+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_10+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,194 :: 		Lcd_Out(2,1,CodeTxtToRamTxt(txt_11));  // Write text in second row ("device connected")
	MOVLW       _txt_11+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_11+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_11+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,195 :: 		Terminate();
	CALL        _Terminate+0, 0
;ExtRes_to_AT45DB.c,196 :: 		}
	GOTO        L_AT45DB_Check22
L_AT45DB_Check21:
	MOVF        AT45DB_Check_density_L0+0, 0 
	XORLW       44
	BTFSC       STATUS+0, 2 
	GOTO        L_AT45DB_Check23
	MOVF        AT45DB_Check_density_L0+0, 0 
	XORLW       52
	BTFSC       STATUS+0, 2 
	GOTO        L_AT45DB_Check24
	GOTO        L_AT45DB_Check25
L_AT45DB_Check22:
;ExtRes_to_AT45DB.c,198 :: 		if (memSize < resFileSize) {
	MOVF        _resFileSize+3, 0 
	SUBWF       _memSize+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__AT45DB_Check68
	MOVF        _resFileSize+2, 0 
	SUBWF       _memSize+2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__AT45DB_Check68
	MOVF        _resFileSize+1, 0 
	SUBWF       _memSize+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__AT45DB_Check68
	MOVF        _resFileSize+0, 0 
	SUBWF       _memSize+0, 0 
L__AT45DB_Check68:
	BTFSC       STATUS+0, 0 
	GOTO        L_AT45DB_Check26
;ExtRes_to_AT45DB.c,199 :: 		Lcd_Out(1,1,CodeTxtToRamTxt(txt_12));  // Write text in first row ("Not enough space")
	MOVLW       _txt_12+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_12+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_12+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,200 :: 		Lcd_Out(2,1,CodeTxtToRamTxt(txt_13));  // Write text in second row ("to store Ext Res")
	MOVLW       _txt_13+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_13+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_13+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,201 :: 		Terminate();
	CALL        _Terminate+0, 0
;ExtRes_to_AT45DB.c,202 :: 		}
L_AT45DB_Check26:
;ExtRes_to_AT45DB.c,203 :: 		}
L_end_AT45DB_Check:
	RETURN      0
; end of _AT45DB_Check

_AT45DB_Write:

;ExtRes_to_AT45DB.c,206 :: 		void AT45DB_Write() {
;ExtRes_to_AT45DB.c,216 :: 		Lcd_Cmd(_LCD_CLEAR);                   // Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;ExtRes_to_AT45DB.c,217 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);              // Cursor off
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;ExtRes_to_AT45DB.c,218 :: 		Lcd_Out(1,1,CodeTxtToRamTxt(txt_14));  // Write text in first row ("Press RA0 button")
	MOVLW       _txt_14+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_14+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_14+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,219 :: 		Lcd_Out(2,1,CodeTxtToRamTxt(txt_15));  // Write text in second row ("to start writing")
	MOVLW       _txt_15+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_15+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_15+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,221 :: 		do {  // Waiting for pressing RA0 button
L_AT45DB_Write27:
;ExtRes_to_AT45DB.c,222 :: 		if (Button(&PORTA, 0, 1, 1))
	MOVLW       PORTA+0
	MOVWF       FARG_Button_port+0 
	MOVLW       hi_addr(PORTA+0)
	MOVWF       FARG_Button_port+1 
	CLRF        FARG_Button_pin+0 
	MOVLW       1
	MOVWF       FARG_Button_time_ms+0 
	MOVLW       1
	MOVWF       FARG_Button_active_state+0 
	CALL        _Button+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_AT45DB_Write30
;ExtRes_to_AT45DB.c,223 :: 		break;
	GOTO        L_AT45DB_Write28
L_AT45DB_Write30:
;ExtRes_to_AT45DB.c,224 :: 		} while (1);
	GOTO        L_AT45DB_Write27
L_AT45DB_Write28:
;ExtRes_to_AT45DB.c,226 :: 		AT45DB_ReadStatusReg();  // Read AT45DB Status Register
	CALL        _AT45DB_ReadStatusReg+0, 0
;ExtRes_to_AT45DB.c,229 :: 		if ((SPI_StatusReg1 & 0b00000001) == 0) {
	MOVLW       1
	ANDWF       _SPI_StatusReg1+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_AT45DB_Write31
;ExtRes_to_AT45DB.c,230 :: 		AT45DB_Chip_Select = 0;                // Select AT45DB memory chip
	BCF         LATC2_bit+0, 2 
;ExtRes_to_AT45DB.c,231 :: 		SPI1_Write(0x3D);                      // Set page size to 512 bytes (opCode 1 of 4)
	MOVLW       61
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,232 :: 		SPI1_Write(0x2A);                      // Set page size to 512 bytes (opCode 2 of 4)
	MOVLW       42
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,233 :: 		SPI1_Write(0x80);                      // Set page size to 512 bytes (opCode 3 of 4)
	MOVLW       128
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,234 :: 		SPI1_Write(0xA6);                      // Set page size to 512 bytes (opCode 4 of 4)
	MOVLW       166
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,235 :: 		AT45DB_Chip_Select = 1;                // Deselect AT45DB memory chip
	BSF         LATC2_bit+0, 2 
;ExtRes_to_AT45DB.c,236 :: 		Lcd_Out(1,1,CodeTxtToRamTxt(txt_16));  // Write text in first row ("Page size is now")
	MOVLW       _txt_16+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_16+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_16+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,237 :: 		Lcd_Out(2,1,CodeTxtToRamTxt(txt_17));  // Write text in second row ("set to 512 bytes")
	MOVLW       _txt_17+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_17+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_17+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,238 :: 		Delay_ms(3000);
	MOVLW       122
	MOVWF       R11, 0
	MOVLW       193
	MOVWF       R12, 0
	MOVLW       129
	MOVWF       R13, 0
L_AT45DB_Write32:
	DECFSZ      R13, 1, 1
	BRA         L_AT45DB_Write32
	DECFSZ      R12, 1, 1
	BRA         L_AT45DB_Write32
	DECFSZ      R11, 1, 1
	BRA         L_AT45DB_Write32
	NOP
	NOP
;ExtRes_to_AT45DB.c,239 :: 		}
L_AT45DB_Write31:
;ExtRes_to_AT45DB.c,241 :: 		Lcd_Out(1,1,CodeTxtToRamTxt(txt_18));  // Write text in first row ("Writing data to ")
	MOVLW       _txt_18+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_18+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_18+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,242 :: 		Lcd_Out(2,1,CodeTxtToRamTxt(txt_19));  // Write text in second row ("45DB16 memory...")
	MOVLW       _txt_19+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_19+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_19+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,244 :: 		cycles = resFileSize / 512;
	MOVLW       9
	MOVWF       R0 
	MOVF        _resFileSize+0, 0 
	MOVWF       AT45DB_Write_cycles_L0+0 
	MOVF        _resFileSize+1, 0 
	MOVWF       AT45DB_Write_cycles_L0+1 
	MOVF        _resFileSize+2, 0 
	MOVWF       AT45DB_Write_cycles_L0+2 
	MOVF        _resFileSize+3, 0 
	MOVWF       AT45DB_Write_cycles_L0+3 
	MOVF        R0, 0 
L__AT45DB_Write70:
	BZ          L__AT45DB_Write71
	RRCF        AT45DB_Write_cycles_L0+3, 1 
	RRCF        AT45DB_Write_cycles_L0+2, 1 
	RRCF        AT45DB_Write_cycles_L0+1, 1 
	RRCF        AT45DB_Write_cycles_L0+0, 1 
	BCF         AT45DB_Write_cycles_L0+3, 7 
	ADDLW       255
	GOTO        L__AT45DB_Write70
L__AT45DB_Write71:
;ExtRes_to_AT45DB.c,245 :: 		remainder = resFileSize % 512;
	MOVLW       255
	ANDWF       _resFileSize+0, 0 
	MOVWF       R0 
	MOVLW       1
	ANDWF       _resFileSize+1, 0 
	MOVWF       R1 
	MOVF        _resFileSize+2, 0 
	MOVWF       R2 
	MOVF        _resFileSize+3, 0 
	MOVWF       R3 
	MOVLW       0
	ANDWF       R2, 1 
	ANDWF       R3, 1 
	MOVF        R0, 0 
	MOVWF       AT45DB_Write_remainder_L0+0 
	MOVF        R1, 0 
	MOVWF       AT45DB_Write_remainder_L0+1 
;ExtRes_to_AT45DB.c,247 :: 		for (i = 0; i < cycles; i++) {
	CLRF        AT45DB_Write_i_L0+0 
	CLRF        AT45DB_Write_i_L0+1 
	CLRF        AT45DB_Write_i_L0+2 
	CLRF        AT45DB_Write_i_L0+3 
L_AT45DB_Write33:
	MOVF        AT45DB_Write_cycles_L0+3, 0 
	SUBWF       AT45DB_Write_i_L0+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__AT45DB_Write72
	MOVF        AT45DB_Write_cycles_L0+2, 0 
	SUBWF       AT45DB_Write_i_L0+2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__AT45DB_Write72
	MOVF        AT45DB_Write_cycles_L0+1, 0 
	SUBWF       AT45DB_Write_i_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__AT45DB_Write72
	MOVF        AT45DB_Write_cycles_L0+0, 0 
	SUBWF       AT45DB_Write_i_L0+0, 0 
L__AT45DB_Write72:
	BTFSC       STATUS+0, 0 
	GOTO        L_AT45DB_Write34
;ExtRes_to_AT45DB.c,248 :: 		for (j = 0; j < 512; j++) {
	CLRF        AT45DB_Write_j_L0+0 
	CLRF        AT45DB_Write_j_L0+1 
L_AT45DB_Write36:
	MOVLW       2
	SUBWF       AT45DB_Write_j_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__AT45DB_Write73
	MOVLW       0
	SUBWF       AT45DB_Write_j_L0+0, 0 
L__AT45DB_Write73:
	BTFSC       STATUS+0, 0 
	GOTO        L_AT45DB_Write37
;ExtRes_to_AT45DB.c,249 :: 		Mmc_Fat_Read(&character);
	MOVLW       AT45DB_Write_character_L0+0
	MOVWF       FARG_Mmc_Fat_Read_fdata+0 
	MOVLW       hi_addr(AT45DB_Write_character_L0+0)
	MOVWF       FARG_Mmc_Fat_Read_fdata+1 
	CALL        _Mmc_Fat_Read+0, 0
;ExtRes_to_AT45DB.c,250 :: 		readBuffer[j]=character;
	MOVLW       _readBuffer+0
	ADDWF       AT45DB_Write_j_L0+0, 0 
	MOVWF       FSR1 
	MOVLW       hi_addr(_readBuffer+0)
	ADDWFC      AT45DB_Write_j_L0+1, 0 
	MOVWF       FSR1H 
	MOVF        AT45DB_Write_character_L0+0, 0 
	MOVWF       POSTINC1+0 
;ExtRes_to_AT45DB.c,248 :: 		for (j = 0; j < 512; j++) {
	INFSNZ      AT45DB_Write_j_L0+0, 1 
	INCF        AT45DB_Write_j_L0+1, 1 
;ExtRes_to_AT45DB.c,251 :: 		}
	GOTO        L_AT45DB_Write36
L_AT45DB_Write37:
;ExtRes_to_AT45DB.c,253 :: 		tempAddr = i << 9;
	MOVLW       9
	MOVWF       R0 
	MOVF        AT45DB_Write_i_L0+0, 0 
	MOVWF       R5 
	MOVF        AT45DB_Write_i_L0+1, 0 
	MOVWF       R6 
	MOVF        AT45DB_Write_i_L0+2, 0 
	MOVWF       R7 
	MOVF        AT45DB_Write_i_L0+3, 0 
	MOVWF       R8 
	MOVF        R0, 0 
L__AT45DB_Write74:
	BZ          L__AT45DB_Write75
	RLCF        R5, 1 
	BCF         R5, 0 
	RLCF        R6, 1 
	RLCF        R7, 1 
	RLCF        R8, 1 
	ADDLW       255
	GOTO        L__AT45DB_Write74
L__AT45DB_Write75:
;ExtRes_to_AT45DB.c,254 :: 		hiAddr = (unsigned short) (tempAddr >> 16);
	MOVF        R7, 0 
	MOVWF       R0 
	MOVF        R8, 0 
	MOVWF       R1 
	CLRF        R2 
	CLRF        R3 
	MOVF        R0, 0 
	MOVWF       AT45DB_Write_hiAddr_L0+0 
;ExtRes_to_AT45DB.c,255 :: 		medAddr = (unsigned short) ((tempAddr & 0xFF00) >> 8);
	MOVLW       0
	ANDWF       R5, 1 
	MOVLW       255
	ANDWF       R6, 1 
	MOVLW       0
	ANDWF       R7, 1 
	ANDWF       R8, 1 
	MOVF        R6, 0 
	MOVWF       R0 
	MOVF        R7, 0 
	MOVWF       R1 
	MOVF        R8, 0 
	MOVWF       R2 
	CLRF        R3 
	MOVF        R0, 0 
	MOVWF       AT45DB_Write_medAddr_L0+0 
;ExtRes_to_AT45DB.c,257 :: 		do {
L_AT45DB_Write39:
;ExtRes_to_AT45DB.c,258 :: 		AT45DB_ReadStatusReg();                      // Read AT45DB Status Register
	CALL        _AT45DB_ReadStatusReg+0, 0
;ExtRes_to_AT45DB.c,259 :: 		} while ((SPI_StatusReg1 & 0b10000000) == 0);  // while "device is busy with an internal operation"
	MOVLW       128
	ANDWF       _SPI_StatusReg1+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_AT45DB_Write39
;ExtRes_to_AT45DB.c,261 :: 		if (memSeries == 'E')
	MOVF        _memSeries+0, 0 
	XORLW       69
	BTFSS       STATUS+0, 2 
	GOTO        L_AT45DB_Write42
;ExtRes_to_AT45DB.c,262 :: 		if ((SPI_StatusReg2 & 0b00100000) != 0) {  // if "erase or program error detected"
	MOVLW       32
	ANDWF       _SPI_StatusReg2+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_AT45DB_Write43
;ExtRes_to_AT45DB.c,263 :: 		Lcd_Out(1,1,CodeTxtToRamTxt(txt_20));    // Write text in first row ("Error writing to")
	MOVLW       _txt_20+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_20+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_20+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,264 :: 		Lcd_Out(2,1,CodeTxtToRamTxt(txt_21));    // Write text in second row ("45DB161E memory.")
	MOVLW       _txt_21+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_21+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_21+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,265 :: 		Terminate();
	CALL        _Terminate+0, 0
;ExtRes_to_AT45DB.c,266 :: 		}
L_AT45DB_Write43:
L_AT45DB_Write42:
;ExtRes_to_AT45DB.c,268 :: 		AT45DB_Chip_Select = 0;  // Select AT45DB Serial Flash chip
	BCF         LATC2_bit+0, 2 
;ExtRes_to_AT45DB.c,269 :: 		SPI1_Write(0x82);        // Main Memory Page Program through Buffer with Built-In Erase
	MOVLW       130
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,270 :: 		SPI1_Write(hiAddr);
	MOVF        AT45DB_Write_hiAddr_L0+0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,271 :: 		SPI1_Write(medAddr);
	MOVF        AT45DB_Write_medAddr_L0+0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,272 :: 		SPI1_Write(0x00);
	CLRF        FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,273 :: 		for (j = 0; j < 512; j++)
	CLRF        AT45DB_Write_j_L0+0 
	CLRF        AT45DB_Write_j_L0+1 
L_AT45DB_Write44:
	MOVLW       2
	SUBWF       AT45DB_Write_j_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__AT45DB_Write76
	MOVLW       0
	SUBWF       AT45DB_Write_j_L0+0, 0 
L__AT45DB_Write76:
	BTFSC       STATUS+0, 0 
	GOTO        L_AT45DB_Write45
;ExtRes_to_AT45DB.c,274 :: 		SPI1_Write(readBuffer[j]);
	MOVLW       _readBuffer+0
	ADDWF       AT45DB_Write_j_L0+0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(_readBuffer+0)
	ADDWFC      AT45DB_Write_j_L0+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,273 :: 		for (j = 0; j < 512; j++)
	INFSNZ      AT45DB_Write_j_L0+0, 1 
	INCF        AT45DB_Write_j_L0+1, 1 
;ExtRes_to_AT45DB.c,274 :: 		SPI1_Write(readBuffer[j]);
	GOTO        L_AT45DB_Write44
L_AT45DB_Write45:
;ExtRes_to_AT45DB.c,275 :: 		AT45DB_Chip_Select = 1;  // Deselect AT45DB Serial Flash chip
	BSF         LATC2_bit+0, 2 
;ExtRes_to_AT45DB.c,247 :: 		for (i = 0; i < cycles; i++) {
	MOVLW       1
	ADDWF       AT45DB_Write_i_L0+0, 1 
	MOVLW       0
	ADDWFC      AT45DB_Write_i_L0+1, 1 
	ADDWFC      AT45DB_Write_i_L0+2, 1 
	ADDWFC      AT45DB_Write_i_L0+3, 1 
;ExtRes_to_AT45DB.c,276 :: 		}
	GOTO        L_AT45DB_Write33
L_AT45DB_Write34:
;ExtRes_to_AT45DB.c,278 :: 		for (j = 0; j < remainder; j++) {
	CLRF        AT45DB_Write_j_L0+0 
	CLRF        AT45DB_Write_j_L0+1 
L_AT45DB_Write47:
	MOVF        AT45DB_Write_remainder_L0+1, 0 
	SUBWF       AT45DB_Write_j_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__AT45DB_Write77
	MOVF        AT45DB_Write_remainder_L0+0, 0 
	SUBWF       AT45DB_Write_j_L0+0, 0 
L__AT45DB_Write77:
	BTFSC       STATUS+0, 0 
	GOTO        L_AT45DB_Write48
;ExtRes_to_AT45DB.c,279 :: 		Mmc_Fat_Read(&character);
	MOVLW       AT45DB_Write_character_L0+0
	MOVWF       FARG_Mmc_Fat_Read_fdata+0 
	MOVLW       hi_addr(AT45DB_Write_character_L0+0)
	MOVWF       FARG_Mmc_Fat_Read_fdata+1 
	CALL        _Mmc_Fat_Read+0, 0
;ExtRes_to_AT45DB.c,280 :: 		readBuffer[j]=character;
	MOVLW       _readBuffer+0
	ADDWF       AT45DB_Write_j_L0+0, 0 
	MOVWF       FSR1 
	MOVLW       hi_addr(_readBuffer+0)
	ADDWFC      AT45DB_Write_j_L0+1, 0 
	MOVWF       FSR1H 
	MOVF        AT45DB_Write_character_L0+0, 0 
	MOVWF       POSTINC1+0 
;ExtRes_to_AT45DB.c,278 :: 		for (j = 0; j < remainder; j++) {
	INFSNZ      AT45DB_Write_j_L0+0, 1 
	INCF        AT45DB_Write_j_L0+1, 1 
;ExtRes_to_AT45DB.c,281 :: 		}
	GOTO        L_AT45DB_Write47
L_AT45DB_Write48:
;ExtRes_to_AT45DB.c,283 :: 		tempAddr = i << 9;
	MOVLW       9
	MOVWF       R0 
	MOVF        AT45DB_Write_i_L0+0, 0 
	MOVWF       R5 
	MOVF        AT45DB_Write_i_L0+1, 0 
	MOVWF       R6 
	MOVF        AT45DB_Write_i_L0+2, 0 
	MOVWF       R7 
	MOVF        AT45DB_Write_i_L0+3, 0 
	MOVWF       R8 
	MOVF        R0, 0 
L__AT45DB_Write78:
	BZ          L__AT45DB_Write79
	RLCF        R5, 1 
	BCF         R5, 0 
	RLCF        R6, 1 
	RLCF        R7, 1 
	RLCF        R8, 1 
	ADDLW       255
	GOTO        L__AT45DB_Write78
L__AT45DB_Write79:
;ExtRes_to_AT45DB.c,284 :: 		hiAddr = (unsigned short) (tempAddr >> 16);
	MOVF        R7, 0 
	MOVWF       R0 
	MOVF        R8, 0 
	MOVWF       R1 
	CLRF        R2 
	CLRF        R3 
	MOVF        R0, 0 
	MOVWF       AT45DB_Write_hiAddr_L0+0 
;ExtRes_to_AT45DB.c,285 :: 		medAddr = (unsigned short) ((tempAddr & 0xFF00) >> 8);
	MOVLW       0
	ANDWF       R5, 1 
	MOVLW       255
	ANDWF       R6, 1 
	MOVLW       0
	ANDWF       R7, 1 
	ANDWF       R8, 1 
	MOVF        R6, 0 
	MOVWF       R0 
	MOVF        R7, 0 
	MOVWF       R1 
	MOVF        R8, 0 
	MOVWF       R2 
	CLRF        R3 
	MOVF        R0, 0 
	MOVWF       AT45DB_Write_medAddr_L0+0 
;ExtRes_to_AT45DB.c,287 :: 		do {
L_AT45DB_Write50:
;ExtRes_to_AT45DB.c,288 :: 		AT45DB_ReadStatusReg();                      // Read AT45DB Status Register
	CALL        _AT45DB_ReadStatusReg+0, 0
;ExtRes_to_AT45DB.c,289 :: 		} while ((SPI_StatusReg1 & 0b10000000) == 0);  // while "device is busy with an internal operation"
	MOVLW       128
	ANDWF       _SPI_StatusReg1+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_AT45DB_Write50
;ExtRes_to_AT45DB.c,291 :: 		if (memSeries == 'E')
	MOVF        _memSeries+0, 0 
	XORLW       69
	BTFSS       STATUS+0, 2 
	GOTO        L_AT45DB_Write53
;ExtRes_to_AT45DB.c,292 :: 		if ((SPI_StatusReg2 & 0b00100000) != 0) {  // if "erase or program error detected"
	MOVLW       32
	ANDWF       _SPI_StatusReg2+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_AT45DB_Write54
;ExtRes_to_AT45DB.c,293 :: 		Lcd_Out(1,1,CodeTxtToRamTxt(txt_20));    // Write text in first row ("Error writing to")
	MOVLW       _txt_20+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_20+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_20+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,294 :: 		Lcd_Out(2,1,CodeTxtToRamTxt(txt_21));    // Write text in second row ("45DB161E memory.")
	MOVLW       _txt_21+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_21+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_21+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,295 :: 		Terminate();
	CALL        _Terminate+0, 0
;ExtRes_to_AT45DB.c,296 :: 		}
L_AT45DB_Write54:
L_AT45DB_Write53:
;ExtRes_to_AT45DB.c,298 :: 		AT45DB_Chip_Select = 0;  // Select AT45DB Serial Flash chip
	BCF         LATC2_bit+0, 2 
;ExtRes_to_AT45DB.c,299 :: 		SPI1_Write(0x82);        // Main Memory Page Program through Buffer with Built-In Erase
	MOVLW       130
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,300 :: 		SPI1_Write(hiAddr);
	MOVF        AT45DB_Write_hiAddr_L0+0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,301 :: 		SPI1_Write(medAddr);
	MOVF        AT45DB_Write_medAddr_L0+0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,302 :: 		SPI1_Write(0x00);
	CLRF        FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,303 :: 		for (j = 0; j < remainder; j++)
	CLRF        AT45DB_Write_j_L0+0 
	CLRF        AT45DB_Write_j_L0+1 
L_AT45DB_Write55:
	MOVF        AT45DB_Write_remainder_L0+1, 0 
	SUBWF       AT45DB_Write_j_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__AT45DB_Write80
	MOVF        AT45DB_Write_remainder_L0+0, 0 
	SUBWF       AT45DB_Write_j_L0+0, 0 
L__AT45DB_Write80:
	BTFSC       STATUS+0, 0 
	GOTO        L_AT45DB_Write56
;ExtRes_to_AT45DB.c,304 :: 		SPI1_Write(readBuffer[j]);
	MOVLW       _readBuffer+0
	ADDWF       AT45DB_Write_j_L0+0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(_readBuffer+0)
	ADDWFC      AT45DB_Write_j_L0+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,303 :: 		for (j = 0; j < remainder; j++)
	INFSNZ      AT45DB_Write_j_L0+0, 1 
	INCF        AT45DB_Write_j_L0+1, 1 
;ExtRes_to_AT45DB.c,304 :: 		SPI1_Write(readBuffer[j]);
	GOTO        L_AT45DB_Write55
L_AT45DB_Write56:
;ExtRes_to_AT45DB.c,305 :: 		for (j = remainder; j < 512; j++)
	MOVF        AT45DB_Write_remainder_L0+0, 0 
	MOVWF       AT45DB_Write_j_L0+0 
	MOVF        AT45DB_Write_remainder_L0+1, 0 
	MOVWF       AT45DB_Write_j_L0+1 
L_AT45DB_Write58:
	MOVLW       2
	SUBWF       AT45DB_Write_j_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__AT45DB_Write81
	MOVLW       0
	SUBWF       AT45DB_Write_j_L0+0, 0 
L__AT45DB_Write81:
	BTFSC       STATUS+0, 0 
	GOTO        L_AT45DB_Write59
;ExtRes_to_AT45DB.c,306 :: 		SPI1_Write(0x00);
	CLRF        FARG_SPI1_Write_data_+0 
	CALL        _SPI1_Write+0, 0
;ExtRes_to_AT45DB.c,305 :: 		for (j = remainder; j < 512; j++)
	INFSNZ      AT45DB_Write_j_L0+0, 1 
	INCF        AT45DB_Write_j_L0+1, 1 
;ExtRes_to_AT45DB.c,306 :: 		SPI1_Write(0x00);
	GOTO        L_AT45DB_Write58
L_AT45DB_Write59:
;ExtRes_to_AT45DB.c,307 :: 		AT45DB_Chip_Select = 1;  // Deselect AT45DB Serial Flash chip
	BSF         LATC2_bit+0, 2 
;ExtRes_to_AT45DB.c,309 :: 		Lcd_Out(1,1,CodeTxtToRamTxt(txt_22));  // Write text in first row ("Data written to ")
	MOVLW       _txt_22+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_22+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_22+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,310 :: 		Lcd_Out(2,1,CodeTxtToRamTxt(txt_23));  // Write text in second row ("AT45DB memory.  ")
	MOVLW       _txt_23+0
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+0 
	MOVLW       hi_addr(_txt_23+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+1 
	MOVLW       higher_addr(_txt_23+0)
	MOVWF       FARG_CodeTxtToRamTxt_ctxt+2 
	CALL        _CodeTxtToRamTxt+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Out_text+0 
	MOVF        R1, 0 
	MOVWF       FARG_Lcd_Out_text+1 
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	CALL        _Lcd_Out+0, 0
;ExtRes_to_AT45DB.c,311 :: 		}
L_end_AT45DB_Write:
	RETURN      0
; end of _AT45DB_Write

_main:

;ExtRes_to_AT45DB.c,314 :: 		void main() {
;ExtRes_to_AT45DB.c,315 :: 		ANSELA = 0;       // Configure PORTA pins as digital (input buttons)
	CLRF        ANSELA+0 
;ExtRes_to_AT45DB.c,316 :: 		ANSELB = 0;       // Configure PORTB pins as digital (LCD display)
	CLRF        ANSELB+0 
;ExtRes_to_AT45DB.c,317 :: 		ANSELC = 0;       // Configure PORTC pins as digital (microSD card and AT45DB device)
	CLRF        ANSELC+0 
;ExtRes_to_AT45DB.c,318 :: 		SLRCON = 0;       // Set output slew rate on all ports at standard rate
	CLRF        SLRCON+0 
;ExtRes_to_AT45DB.c,319 :: 		TRISA = 0x01;     // Set direction of RA0 pin to be input
	MOVLW       1
	MOVWF       TRISA+0 
;ExtRes_to_AT45DB.c,321 :: 		Lcd_Init();       // Initialize LCD module
	CALL        _Lcd_Init+0, 0
;ExtRes_to_AT45DB.c,322 :: 		Wait_for_Card();  // Wait for microSD card insertion
	CALL        _Wait_for_Card+0, 0
;ExtRes_to_AT45DB.c,323 :: 		Card_Init();      // Initialize SPI1 module and microSD card
	CALL        _Card_Init+0, 0
;ExtRes_to_AT45DB.c,324 :: 		AT45DB_Check();   // Check for valid AT45DB device connected
	CALL        _AT45DB_Check+0, 0
;ExtRes_to_AT45DB.c,325 :: 		AT45DB_Write();   // Write data to AT45DB SPI Serial Flash memory
	CALL        _AT45DB_Write+0, 0
;ExtRes_to_AT45DB.c,326 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
